From e5ea14e0492721b2c7346d679885ce138512f8da Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Dec 10 2020 07:11:19 +0000
Subject: [PATCH 1680/2232] Merge pull request #556 from dtolnay/functional


Include <functional> when deriving Hash impl shim
---

diff --git a/gen/src/include.rs b/gen/src/include.rs
index 9db95be..3a0d66b 100644
--- a/gen/src/include.rs
+++ b/gen/src/include.rs
@@ -27,6 +27,7 @@ pub struct Includes<'a> {
     pub cstdint: bool,
     pub cstring: bool,
     pub exception: bool,
+    pub functional: bool,
     pub initializer_list: bool,
     pub iterator: bool,
     pub memory: bool,
@@ -77,6 +78,7 @@ pub(super) fn write(out: &mut OutFile) {
         cstdint,
         cstring,
         exception,
+        functional,
         initializer_list,
         iterator,
         memory,
@@ -107,6 +109,9 @@ pub(super) fn write(out: &mut OutFile) {
     if exception {
         writeln!(out, "#include <exception>");
     }
+    if functional {
+        writeln!(out, "#include <functional>");
+    }
     if initializer_list {
         writeln!(out, "#include <initializer_list>");
     }
diff --git a/gen/src/write.rs b/gen/src/write.rs
index 28a3eec..e29d5f6 100644
--- a/gen/src/write.rs
+++ b/gen/src/write.rs
@@ -158,6 +158,7 @@ fn write_std_specializations(out: &mut OutFile, apis: &[Api]) {
         if let Api::Struct(strct) = api {
             if derive::contains(&strct.derives, Trait::Hash) {
                 out.next_section();
+                out.include.functional = true;
                 let qualified = strct.name.to_fully_qualified();
                 writeln!(out, "template <> struct hash<{}> {{", qualified);
                 writeln!(

